## freeart 3.3.0+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project (FreeART)

# get python to make it work
find_package(PythonLibs REQUIRED)

FILE(GLOB INCLUDE_FILES_H ${CMAKE_SOURCE_DIR}/freeart/core/include/*.h)
FILE(GLOB INCLUDE_FILES_HPP ${CMAKE_SOURCE_DIR}/freeart/core/include/*.hpp)
FILE(GLOB SRC_FILES ${CMAKE_SOURCE_DIR}/freeart/core/src/*.cpp)

MESSAGE( STATUS ${CMAKE_SOURCE_DIR})
MESSAGE( STATUS "___ \n" )
MESSAGE( STATUS ${SRC_FILES} )

include_directories(${CMAKE_SOURCE_DIR}/freeart/core/include)
include_directories(${CMAKE_SOURCE_DIR}/freeart/core/src)
include_directories(${PYTHON_INCLUDE_DIRS})

add_library(FreeART SHARED ${INCLUDE_FILES_H} ${INCLUDE_FILES_HPP} ${SRC_FILES})
SET_TARGET_PROPERTIES(FreeART PROPERTIES LINKER_LANGUAGE CXX)

message(STATUS FreeART ${FreeART} )

add_subdirectory(examples/cpp)

=== requirements.txt ===
# List all dependencies of freeart
# Requires pip >= 8.0

silx  >=0.8 # needed for configdict ( and to display the benchmark)
fabio  # needed for edf files
fisx   # needed for materials absorption estimation
Cython >= 0.21
h5py

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== examples/cpp/CMakeLists.txt ===
# CMakeLists files in this project can
# refer to the root source directory of the project as ${HELLO_SOURCE_DIR} and
# to the root binary directory of the project as ${HELLO_BINARY_DIR}.
cmake_minimum_required (VERSION 2.8.11)
project (examples_cpp)

include_directories(${CMAKE_SOURCE_DIR}/freeart/core/include)
include_directories(${CMAKE_SOURCE_DIR}/freeart/core/src)
include_directories(${CMAKE_SOURCE_DIR}/freeart/cpp_utils)

# add all executables
add_executable(projector_tx projector_tx.cpp)
add_executable(projector_fluo projector_fluo.cpp)
add_executable(reconstr_tx reconstr_tx.cpp)
add_executable(reconstr_fluo reconstr_fluo.cpp)

# linking the library
target_link_libraries (projector_tx FreeART)
target_link_libraries (projector_fluo FreeART)
target_link_libraries (reconstr_tx FreeART)
target_link_libraries (reconstr_fluo FreeART)

SET( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -w" )

=== debian/changelog ===
freeart (3.3.0+ds1-3) unstable; urgency=medium

  * Source-only upload for migration to testing.

 -- Roland Mas <lolando@debian.org>  Wed, 16 Feb 2022 14:36:31 +0100

freeart (3.3.0+ds1-2) unstable; urgency=medium

  * Update debian/copyright for specially licensed files:
    freeart/core/include/*, freeart/core/src/GeometryFactory.cpp.

 -- Roland Mas <lolando@debian.org>  Tue, 01 Feb 2022 20:36:03 +0100

freeart (3.3.0+ds1-1) unstable; urgency=low

  * Initial upload (closes: #996247).
  * source package automatically created by stdeb 0.10.0 then tweaked by hand.

 -- Roland Mas <lolando@debian.org>  Wed, 13 Oct 2021 21:05:24 +0200

=== debian/control ===
Source: freeart
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Roland Mas <lolando@debian.org>
Section: python
Priority: optional
Build-Depends: dh-python, python3-setuptools, python3-dev,
 cython3, python3-numpy, python3-fabio, python3-silx, python3-fisx,
 help2man, python3-sphinx, debhelper (>= 13)
Standards-Version: 4.5.1
Homepage: https://gitlab.esrf.fr/freeart/freeart
Vcs-Git: https://salsa.debian.org/python-team/packages/freeart.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/freeart

Package: python3-freeart
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, libjs-sphinxdoc, libjs-jquery,
 libjs-underscore
Description: Software library for X-Ray data analysis
 Freeart is a tomographic image reconstruction library using Algebraic
 Reconstruction Technique (ART).  It is able to deal with absorption
 and emission sinograms.  Freeart core is written in C++ using
 template classes to have simple or double precision.  A python
 interface is provided to access the core functionalities.  A set of
 utils such as configuration files, interpreter to run reconstruction
 from configuration files are provided in python.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=freeart
%:
	dh $@ --with python3 --buildsystem=pybuild

# Only build the Python stuff, so no need for auto*
override_dh_autoreconf:

# Disable testsuite for now
override_dh_auto_test:

override_dh_auto_build:
	python3 setup.py build build_man build_doc
	rm -f $(CURDIR)/debian/python3-freeart/usr/share/doc/python3-freeart/html/_static/jquery.js
	rm -f $(CURDIR)/debian/python3-freeart/usr/share/doc/python3-freeart/html/_static/doctools.js
	rm -f $(CURDIR)/debian/python3-freeart/usr/share/doc/python3-freeart/html/_static/searchtools.js
	rm -f $(CURDIR)/debian/python3-freeart/usr/share/doc/python3-freeart/html/_static/underscore.js
	rm -f $(CURDIR)/debian/python3-freeart/usr/share/doc/python3-freeart/html/_static/language_data.js

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d+//,repacksuffix=+ds1,\
 " \
 https://gitlab.esrf.fr/freeart/freeart/tags?sort=updated_desc archive/v@ANY_VERSION@/@PACKAGE@-v\d\S*\.tar\.gz debian uupdate
